#include"stm32f10x_lib.h"
#include"defs.h"
#include"class.h"
void RCC_Configuration(void);
void NVIC_Configuration(void);
void putcH(unsigned char);
void putS(char *);
unsigned char getcH(void);
void Delay(vu32 nCount)
{
  for(; nCount != 0; nCount--);
}
ErrorStatus HSEStartUpStatus;

int main(void)
{	
	RCC_Configuration();
	NVIC_Configuration();
	
	RCC_APB2ENR=(1<<AFIOEN)|(1<<IOPBEN)|(1<<IOPAEN);									
	GPIOB_CRH=0x22222222;													//set all to push-pull outputs
	
	USART usart;
	usart.putS("Ich bin eine Klassse");

	while (1)
	{
		GPIOB_BSRR = (1 << 8)|(1<<31);
		Delay(DELAYTIME);
		GPIOB_BSRR=(1 << 24)|(1 << 9); 
		Delay(DELAYTIME);
		GPIOB_BSRR=(1 << 25)|(1 << 10); 
		Delay(DELAYTIME);
		GPIOB_BSRR=(1 << 26)|(1 << 11); 
		Delay(DELAYTIME);
		GPIOB_BSRR=(1 << 27)|(1 << 12); 
		Delay(DELAYTIME);
		GPIOB_BSRR=(1 << 28)|(1 << 13); 
		Delay(DELAYTIME);
		GPIOB_BSRR=(1 << 29)|(1 << 14); 
		Delay(DELAYTIME);
		GPIOB_BSRR=(1 << 30)|(1 << 15); 
		Delay(DELAYTIME);

		/*usart.putS("Sie haben ");
		usart.putcH(usart.getcH());
		usart.putS(" gedrueckt\n\r");*/
	}
}



void NVIC_Configuration()
{
#ifdef  VECT_TAB_RAM  
  /* Set the Vector Table base location at 0x20000000 */ 
  NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0); 
#else  /* VECT_TAB_FLASH  */
  /* Set the Vector Table base location at 0x08000000 */ 
  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);   
#endif
}

void RCC_Configuration()
{
	RCC_DeInit();
	  RCC_HSEConfig(RCC_HSE_ON);

  /* Wait till HSE is ready */
  HSEStartUpStatus = RCC_WaitForHSEStartUp();

  if(HSEStartUpStatus == SUCCESS)
  {
    /* Enable Prefetch Buffer */
    FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

    /* Flash 2 wait state */
    FLASH_SetLatency(FLASH_Latency_2);
 	
    /* HCLK = SYSCLK */
    RCC_HCLKConfig(RCC_SYSCLK_Div1); 
  
    /* PCLK2 = HCLK */
    RCC_PCLK2Config(RCC_HCLK_Div1); 

    /* PCLK1 = HCLK/2 */
    RCC_PCLK1Config(RCC_HCLK_Div2);

    /* PLLCLK = 8MHz * 9 = 72 MHz */
    RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);

    /* Enable PLL */ 
    RCC_PLLCmd(ENABLE);

    /* Wait till PLL is ready */
    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
    {
    }

    /* Select PLL as system clock source */
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    /* Wait till PLL is used as system clock source */
    while(RCC_GetSYSCLKSource() != 0x08)
    {
    }
  }
}